#include <iostream>
#include <omp.h>

#include <cstdlib>
#include <string>
#include <stdio.h>


  void hello_world_from_any();

  void testThreadCount();

  std::string get_device_name();

int main(int argc, char *argv[])
{
  hello_world_from_any();
  testThreadCount();

  exit(0);
}

std::string get_device_name()
{
#ifdef __MIC
  std::string device_name = "MIC ";
#else
  std::string device_name = "HOST";
#endif // __MIC__

 return device_name;
}

void hello_world_from_any()
{
  std::cout << "***** Hello by " << get_device_name() << " *****" << std::endl;
} 


void testThreadCount()
{
   #pragma omp parallel
   {
     int tid = omp_get_thread_num();
     #pragma omp critical
     {  
       std::cout << "Hello by thread id: " << tid << std::endl;
     }
     #pragma omp barrier
     #pragma omp single
     {
       int thread_count = omp_get_num_threads();
       #pragma omp critical
       {
         std::cout << "Thread count: " << thread_count << std::endl;
         std::cout << "======================================" << std::endl;
       }
     }  
  }
}
